unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Unit2, ExtCtrls, Buttons,
  About, Gauges, UScores, IniFiles, CalkView;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    FeuilleDeCalcul1: TFeuilleDeCalcul;
    Label4: TLabel;
    Panel1: TPanel;
    ReponseButton: TSpeedButton;
    CalcButton: TSpeedButton;
    HelpButton: TSpeedButton;
    AboutButton: TSpeedButton;
    QuitButton: TSpeedButton;
    OpenDialog1: TOpenDialog;
    OpenButton: TSpeedButton;
    NextButton: TSpeedButton;
    PrevButton: TSpeedButton;
    Gauge1: TGauge;
    IdentLabel: TLabel;
    Panel2: TPanel;
    Image1: TImage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ReponseButtonClick(Sender: TObject);
    procedure CalcButtonClick(Sender: TObject);
    procedure QuitButtonClick(Sender: TObject);
    procedure AboutButtonClick(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HelpButtonClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-dclarations }
    ExoFile : String;
    ExoTab  : TList;
    NumExo  : Integer;
    Table   : PTableau;
    ScoI    : Integer;
    NombreExo : Integer;
    ScoCode : String[8];
    procedure ChargeExo(num:Integer);
    procedure ChargeFichier(NomFichier:String);
    procedure Verification;
    procedure ExoSuivant;
    procedure ExoPrecedent;
    procedure Vidange;
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var S:String;
    i,n:Integer;
    ok:Boolean;
    Id:TIdent;
    IniFile:TIniFile;
begin
 Color:=RGB(0,128,255);
 ExoFile:='';
 Table:=nil;
 ExoTab:=nil;
 IniFile:=TIniFile.Create('lilimath.ini');
 ScoPath:=IniFile.ReadString('Installation','Dossier','');
 IniFile.Free;
 if ScoPath<>'' then ScoPath:=ScoPath+'\Exer6'
 else ScoPath:=ExtractFilePath(paramstr(0));
 if ScoPath<>'' then
  if ScoPath[length(ScoPath)]<>'\' then
    ScoPath:=ScoPath+'\';
 n:=paramcount;
 if n>0 then
  begin
   ok:=false;
   i:=1;
   repeat
    S:=paramstr(i);
    ok:=CodeOk(S);
    if not ok then inc(i);
   until ok or (i>n);
   if ok then
    begin
     ScoCode:=S;
     ReadIdent(ScoCode,Id);
     IdentLabel.Caption:=Id.Nom+' '+Id.Prenom;
    end;
  end;
 if ((not ok) and (n>0)) or (ok and (n>1)) then
  S:=paramstr(1)
 else S:='exocalc.dat';
 ChargeFichier(S);
end;

procedure TForm1.ChargeExo(num:Integer);
var i : Integer;
    list : TStringList;
begin
 NumExo:=num;
 list:=ExoTab.Items[Table^[num].num];
 Label1.Caption:='Thme : '+list.Strings[0];
 Label2.Caption:='Enonc : '+IntToStr(num+1)+
  ' sur '+IntToStr(NombreExo);
 Memo1.Clear;
 for i:=2 to list.Count-1 do
  Memo1.Lines.Add(list.Strings[i]);
 ScoI:=round(100/NombreExo);
end;

procedure TForm1.ChargeFichier(NomFichier:String);
var ExoValid : Boolean;
    S,So     : String;
    f        : TextFile;
    list     : TStringList;
begin
 Vidange;
 Gauge1.Progress:=0;
 FeuilleDeCalcul1.Clear;
 ExoFile:=NomFichier;
 ExoTab:=TList.Create;
 ExoValid:=true;
 list:=nil;
 S:='';
 assignfile(f,ExoFile);
 {$I-}
 reset(f);
 {$I+}
 if IOResult<>0 then ExoValid:=false;
 while not EOF(f) and ExoValid do
  begin
   {$I-}
   readln(f,So);
   {$I+}
   if IOResult<>0 then
    ExoValid:=false
   else
    begin
     S[0]:=So[0];
     OemToAnsiBuff(@So[1],@S[1],Byte(So[0]));
     if S[1]='#' then
      begin
       if list<>nil then ExoTab.Add(list);
       list:=TStringList.Create;
       S:=copy(S,2,length(S)-1);
       list.Add(S);
      end
     else
      begin
       if (S<>'') and (S[1]<>'''') and (S[1]<>';') then
        begin
         if list<>nil then
          list.Add(S)
         else ExoValid:=false;
        end;
      end;
    end;
  end;
 if list<>nil then ExoTab.Add(list);
 {$I-}
 closefile(f);
 {$I+}
 if not ExoValid then
  begin
   MessageDlg('Fichier de donnes absent ou non valide.',
         mtInformation,[mbOk],0);
   Application.Terminate;
   exit;
  end
 else
  begin
   if ExoTab.Count>=10 then
    NombreExo:=10
   else NombreExo:=ExoTab.Count;
   Table:=DonneTableau(ExoTab.Count);
   ChargeExo(0);
  end;
end;

procedure TForm1.Vidange;
begin
 if Table<>nil then
  begin
   freemem(Table,ExoTab.Count*sizeof(TExoRec));
   Table:=nil;
  end;
 ExoTab.Free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Vidange;
end;

procedure TForm1.Verification;
var Rep,S,Msg : String;
    i : Integer;
    list : TStringList;
    bip : Boolean;
begin
 bip:=false;
 Rep:=Edit1.Text;
 if Rep='' then
  begin
   Msg:='Il faut donner une rponse !';
   exit;
  end
 else
  begin
   while Rep[1]=' ' do system.delete(Rep,1,1);
   for i:=1 to length(Rep) do if Rep[i]='.' then Rep[i]:=',';
   list:=ExoTab.Items[Table^[NumExo].num];
   S:=list.Strings[1];
   if pos(Rep,S)<>0 then
    Msg:='Bonne rponse.'
   else
    begin
     bip:=true;
     dec(ScoI,4);
     if ScoI>0 then
      Msg:='Ce n''est pas la rponse attendue !'
     else Msg:= 'Faux. La rponse est '+S;
    end;
  end;
if bip then
 begin
  MessageBeep(0);
  MessageDlg(Msg,mtInformation,[mbOk],0);
  if ScoI<=0 then
   ExoSuivant;
 end
else
 begin
  MessageDlg(Msg,mtInformation,[mbOk],0);
  Gauge1.Progress:=Gauge1.Progress + ScoI;
  Table^[NumExo].Sco:=ScoI;
  ExoSuivant;
 end;
end;

procedure TForm1.ExoSuivant;
var actu,n:Integer;
begin
 actu:=NumExo;
 n:=actu;
 repeat
  if n<NombreExo-1 then
   n:=n+1
  else n:=0;
 until (Table^[n].Sco<0) or (n=actu);
 if n=Actu then close
 else
  begin
   Edit1.Text:='';
   ChargeExo(n);
   FeuilleDeCalcul1.SetFocus;
  end;
end;

procedure TForm1.ExoPrecedent;
var actu,n:Integer;
begin
 actu:=NumExo;
 n:=actu;
 repeat
  if n>0 then
   n:=n-1
  else n:=NombreExo-1;
 until (Table^[n].Sco<0) or (n=actu);
 if n=actu then close
 else
  begin
   Edit1.Text:='';
   ChargeExo(n);
   FeuilleDeCalcul1.SetFocus;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 FeuilleDeCalcul1.SetFocus;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  begin
   Verification;
   Key:=#0;
  end;
end;

procedure TForm1.ReponseButtonClick(Sender: TObject);
begin
Edit1.SetFocus;
end;

procedure TForm1.CalcButtonClick(Sender: TObject);
begin
FeuilleDeCalcul1.SetFocus;
end;

procedure TForm1.QuitButtonClick(Sender: TObject);
begin
close;
end;

procedure TForm1.AboutButtonClick(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TForm1.OpenButtonClick(Sender: TObject);
begin
with OpenDialog1 do
 if Execute then ChargeFichier(FileName);
end;

procedure TForm1.NextButtonClick(Sender: TObject);
begin
ExoSuivant;
end;

procedure TForm1.PrevButtonClick(Sender: TObject);
begin
ExoPrecedent;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var S:String;
    Score:TScore;
    Id:TIdent;
begin
CanClose:=true;
if (ScoCode<>'') and (Gauge1.Progress>=1) then
 begin
  if Gauge1.Progress>=75 then
   begin
    S:='Exercice russi.'+chr(13);
    S:=S+'Tu marques '+IntToStr(Gauge1.Progress)+' points.';
   end
  else
   begin
    S:='Tu ne marques que '+IntToStr(Gauge1.Progress)+' point';
    if Gauge1.Progress>1 then S:=S+'s';
    S:=S+'.';
   end;
  MessageDlg(S,mtInformation,[mbOk],0);
  with Score do
   begin
    Theme:=ExtractFileName(ExoFile);
    Prog:=ExtractFileName(Application.ExeName);
    NbEssais:=0;
    Result:=0;
   end;
  GetScore(ScoCode, Score, Id);
  inc(Score.NbEssais);
  if Score.Result<Gauge1.Progress then
   Score.Result:=Gauge1.Progress;
  ScoreUpdate(ScoCode,Score);
 end;
end;

procedure TForm1.HelpButtonClick(Sender: TObject);
begin
Application.HelpJump('Main_Index');
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=vk_F1 then
 begin
  HelpButtonClick(Sender);
  key:=0;
 end;
end;

end.
