Unit UScores;
{ Pierre Andr Caron et Kostrzewa Bruno
  Mai 1996 }

INTERFACE

Uses SysUtils;

Type
 TStr8=String[8];
 TStr10=String[10];
 TStr20=String[20];

 TIdent = record
  Nom      : TStr20;
  Prenom   : TStr20;
  Classe   : TStr10;
  End;

 TScore = record
  Theme    : TStr8;
  Prog     : TStr8;
  NbEssais : Integer;
  Result   : Integer;
  End;

Var ScoPath : String;

{ procdures de gestion des scores }

Function CodeOk(Code:TStr8):Boolean;
{ indique si le fichier score existe }

Procedure ScoreUpdate(Code:TStr8; Score:TScore);
{ mise  jour du fichier .sco avec le contenu de Score }

Procedure GetScore(Code:TStr8; Var Score:TScore; Var Id:TIdent);
{ lecture du fichier .sco, Score doit tre initialis avec le
  nom du programme et le thme cherch }

Function  ScoreInit(Code:TStr8; Id:TIdent): Boolean;
{ cration d'un fichier .sco }

Procedure ReadIdent(Code:TStr8; Var Id:TIdent);
{ lecture du nom, du prnom et de la classe }

IMPLEMENTATION

Function CodeOk(Code:TStr8):Boolean;
Begin
 Result:=FileExists(ScoPath+Code+'.sco');
End;

Procedure ScoreUpdate(Code:TStr8; Score:TScore);
Var f   : File;
    Id  : TIdent;
    W   : TScore;
    p   : LongInt;
    res : Word;
    ok  : Boolean;
Begin
 ok:=false;
 assign(f,ScoPath+Code+'.sco');
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult<>0
    then begin
          exit;
         end;
 blockread(f,Id,sizeof(TIdent));
 repeat
  p:=filepos(f);
  blockread(f,W,sizeof(TScore),res);
  if (res=sizeof(TScore)) and (W.Theme=Score.Theme) and (W.Prog=Score.Prog)
     then begin
           seek(f,p);
           blockwrite(f,Score,sizeof(TScore));
           ok:=true;
          end;
 until ok or (res=0);
 if not ok
    then blockwrite(f,Score,sizeof(TScore));
 close(f);
End;

Procedure GetScore(Code:TStr8; Var Score:TScore; Var Id:TIdent);
Var f   : File;
    W   : TScore;
    res : Word;
    ok  : Boolean;
Begin
 Score.NbEssais:=0;
 Score.Result:=0;
 assign(f,ScoPath+Code+'.sco');
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult<>0
    then begin
          exit;
         end;
 blockread(f,Id,sizeof(Id));
 ok:=false;
 repeat
  blockread(f,W,sizeof(TScore),res);
  if (res=sizeof(TScore)) and (W.Theme=Score.Theme) and (W.Prog=Score.Prog)
     then begin
           Score:=W;
           ok:=true;
          end;
 until ok or (res<>sizeof(TScore));
 close(f);
End;

Function ScoreInit(Code:TStr8; Id:TIdent):Boolean;
Var f:File;
Begin
 assign(f,ScoPath+Code+'.sco');
 {$I-}
 rewrite(f,1);
 {$I+}
 if IOResult<>0
    then begin
          ScoreInit:=false;
          exit;
         end;
 blockwrite(f,Id,sizeof(Id));
 close(f);
 ScoreInit:=true;
End;

Procedure ReadIdent(Code:TStr8; Var Id:TIdent);
Var f:File;
Begin
 assign(f,ScoPath+Code+'.sco');
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult<>0
    then begin
          Id.Nom:='';
          Id.Prenom:='';
          Id.Classe:='';
          exit;
         end;
 blockread(f,Id,sizeof(Id));
 close(f);
End;

BEGIN
 ScoPath:='';
END.
{                            Fin du fichier UScores.PAS                       }

